<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>cnp.nparray &#8212; numpy 0.0.post1.dev4+gdc3df0d documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=a3874995"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for cnp.nparray</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">.common</span> <span class="kn">import</span> <span class="n">generator</span><span class="p">,</span> <span class="n">processor</span><span class="p">,</span> <span class="n">params_to_dict</span>
<span class="kn">import</span> <span class="nn">logging</span>
<span class="kn">import</span> <span class="nn">click</span> 
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">ast</span> <span class="kn">import</span> <span class="n">literal_eval</span>
<span class="kn">from</span> <span class="nn">functools</span> <span class="kn">import</span> <span class="n">update_wrapper</span>


<div class="viewcode-block" id="random">
<a class="viewcode-back" href="../../api/cnp.html#cnp.nparray.random">[docs]</a>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-s&quot;</span><span class="p">,</span> <span class="s2">&quot;--size&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="s2">&quot;1&quot;</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Size of the random array as int (vector) or comma-separated list of ints (N-dim array).&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-m&quot;</span><span class="p">,</span> <span class="s2">&quot;--min&quot;</span><span class="p">,</span> <span class="s2">&quot;min_&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="mf">0.0</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Minimum value.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-M&quot;</span><span class="p">,</span> <span class="s2">&quot;--max&quot;</span><span class="p">,</span> <span class="s2">&quot;max_&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="mf">1.0</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Maximum value.&quot;</span><span class="p">)</span>
<span class="nd">@generator</span>
<span class="k">def</span> <span class="nf">random</span><span class="p">(</span><span class="n">size</span><span class="p">,</span> <span class="n">min_</span><span class="p">,</span> <span class="n">max_</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;Generates an array of ``size`` random values from [min, max].&quot;&quot;&quot;</span>
    <span class="n">size_</span> <span class="o">=</span> <span class="p">[</span><span class="nb">int</span><span class="p">(</span><span class="n">s</span><span class="o">.</span><span class="n">strip</span><span class="p">())</span> <span class="k">for</span> <span class="n">s</span> <span class="ow">in</span> <span class="n">size</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;,&quot;</span><span class="p">)]</span>
    <span class="n">min_</span><span class="p">,</span> <span class="n">max_</span> <span class="o">=</span> <span class="p">(</span><span class="n">min_</span><span class="p">,</span> <span class="n">max_</span><span class="p">)</span> <span class="k">if</span> <span class="n">min_</span> <span class="o">&lt;</span> <span class="n">max_</span> <span class="k">else</span> <span class="p">(</span><span class="n">max_</span><span class="p">,</span> <span class="n">min_</span><span class="p">)</span>
    <span class="n">span</span> <span class="o">=</span> <span class="p">(</span><span class="n">max_</span> <span class="o">-</span> <span class="n">min_</span><span class="p">)</span>
    <span class="k">yield</span> <span class="n">span</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">random</span><span class="p">(</span><span class="n">size_</span><span class="p">)</span> <span class="o">+</span> <span class="n">min_</span></div>


<span class="c1"># ----- Generators ----- #</span>

<div class="viewcode-block" id="elementwise_unary_generator">
<a class="viewcode-back" href="../../api/cnp.html#cnp.nparray.elementwise_unary_generator">[docs]</a>
<span class="k">def</span> <span class="nf">elementwise_unary_generator</span><span class="p">(</span><span class="n">func</span><span class="p">):</span>
    <span class="nd">@processor</span>
    <span class="k">def</span> <span class="nf">unary</span><span class="p">(</span><span class="n">arrays</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">arr</span> <span class="ow">in</span> <span class="n">arrays</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">func</span><span class="p">(</span><span class="n">arr</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">update_wrapper</span><span class="p">(</span><span class="n">unary</span><span class="p">,</span> <span class="n">func</span><span class="p">)</span></div>



<div class="viewcode-block" id="axiswise_unary_generator">
<a class="viewcode-back" href="../../api/cnp.html#cnp.nparray.axiswise_unary_generator">[docs]</a>
<span class="k">def</span> <span class="nf">axiswise_unary_generator</span><span class="p">(</span><span class="n">func</span><span class="p">):</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--axis&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span> 
        <span class="n">default</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Sets the axis along which the operation is to be performed. &quot;</span> \
            <span class="s2">&quot;Default is to apply the operation on the flattened array.&quot;</span>
    <span class="p">)</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--params&quot;</span><span class="p">,</span>
        <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;String of function options in the format &#39;param1=value1|param2=value2|...&#39;.&quot;</span>
    <span class="p">)</span>
    <span class="nd">@processor</span>
    <span class="k">def</span> <span class="nf">wrapper</span><span class="p">(</span><span class="n">arrays</span><span class="p">,</span> <span class="n">axis</span><span class="p">,</span> <span class="n">params</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">arr</span> <span class="ow">in</span> <span class="n">arrays</span><span class="p">:</span>
            <span class="n">opts</span> <span class="o">=</span> <span class="n">params_to_dict</span><span class="p">(</span><span class="n">params</span><span class="p">)</span> <span class="k">if</span> <span class="n">params</span> <span class="k">else</span> <span class="nb">dict</span><span class="p">()</span>
            <span class="k">yield</span> <span class="n">func</span><span class="p">(</span><span class="n">arr</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="n">axis</span><span class="p">,</span> <span class="o">**</span><span class="n">opts</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">update_wrapper</span><span class="p">(</span><span class="n">wrapper</span><span class="p">,</span> <span class="n">func</span><span class="p">)</span></div>



<div class="viewcode-block" id="binary_generator">
<a class="viewcode-back" href="../../api/cnp.html#cnp.nparray.binary_generator">[docs]</a>
<span class="k">def</span> <span class="nf">binary_generator</span><span class="p">(</span><span class="n">func</span><span class="p">):</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--pairs&quot;</span><span class="p">,</span> <span class="s2">&quot;how&quot;</span><span class="p">,</span>
        <span class="n">flag_value</span><span class="o">=</span><span class="s2">&quot;pairs&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Add pairs of arrays, e.g. [a, b, c, d] -&gt; [a+b, c+d].&quot;</span><span class="p">)</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--adjacent&quot;</span><span class="p">,</span> <span class="s2">&quot;how&quot;</span><span class="p">,</span>
        <span class="n">flag_value</span><span class="o">=</span><span class="s2">&quot;adjacent&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Add adjacent arrays, e.g. [a, b, c, d] -&gt; [a+b, b+c, c+d].&quot;</span><span class="p">)</span>
    <span class="nd">@processor</span>
    <span class="k">def</span> <span class="nf">binary</span><span class="p">(</span><span class="n">arrays</span><span class="p">,</span> <span class="n">how</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;Add arguments element-wise.&quot;&quot;&quot;</span>
        <span class="n">queue</span> <span class="o">=</span> <span class="p">[</span><span class="n">arr</span> <span class="k">for</span> <span class="n">arr</span> <span class="ow">in</span> <span class="n">arrays</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">how</span> <span class="o">==</span> <span class="s2">&quot;pairs&quot;</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">queue</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">],</span> <span class="n">queue</span><span class="p">[</span><span class="mi">1</span><span class="p">::</span><span class="mi">2</span><span class="p">]):</span>
                <span class="k">yield</span> <span class="n">func</span><span class="p">(</span><span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">how</span> <span class="o">==</span> <span class="s2">&quot;adjacent&quot;</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">queue</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">queue</span><span class="p">[</span><span class="mi">1</span><span class="p">:]):</span>
                <span class="k">yield</span> <span class="n">func</span><span class="p">(</span><span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;The requested addition method is not supported.&quot;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">update_wrapper</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">func</span><span class="p">)</span></div>



<div class="viewcode-block" id="binary_ufunc_generator">
<a class="viewcode-back" href="../../api/cnp.html#cnp.nparray.binary_ufunc_generator">[docs]</a>
<span class="k">def</span> <span class="nf">binary_ufunc_generator</span><span class="p">(</span><span class="n">ufunc</span><span class="p">):</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--pairs&quot;</span><span class="p">,</span> <span class="s2">&quot;how&quot;</span><span class="p">,</span>
        <span class="n">flag_value</span><span class="o">=</span><span class="s2">&quot;pairs&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Add pairs of arrays, e.g. [a, b, c, d] -&gt; [a+b, c+d].&quot;</span><span class="p">)</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--adjacent&quot;</span><span class="p">,</span> <span class="s2">&quot;how&quot;</span><span class="p">,</span>
        <span class="n">flag_value</span><span class="o">=</span><span class="s2">&quot;adjacent&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Add adjacent arrays, e.g. [a, b, c, d] -&gt; [a+b, b+c, c+d].&quot;</span><span class="p">)</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--reduce&quot;</span><span class="p">,</span> <span class="s2">&quot;how&quot;</span><span class="p">,</span>
        <span class="n">flag_value</span><span class="o">=</span><span class="s2">&quot;reduce&quot;</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Add all arrays, e.g. [a, b, c, d] -&gt; [a+b+c+d]. (Default.)&quot;</span><span class="p">)</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--accumulate&quot;</span><span class="p">,</span> <span class="s2">&quot;how&quot;</span><span class="p">,</span>
        <span class="n">flag_value</span><span class="o">=</span><span class="s2">&quot;accumulate&quot;</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Accumulate the operation, e.g. [a, b, c, d] -&gt; [a, a+b, a+b+c. a+b+c+d].&quot;</span><span class="p">)</span>
    <span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
        <span class="s2">&quot;--outer&quot;</span><span class="p">,</span>
        <span class="n">is_flag</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
        <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Cartesian addition for all (a, b) pairs from above.&quot;</span><span class="p">)</span>
    <span class="nd">@processor</span>
    <span class="k">def</span> <span class="nf">binary</span><span class="p">(</span><span class="n">arrays</span><span class="p">,</span> <span class="n">how</span><span class="p">,</span> <span class="n">outer</span><span class="p">):</span>
<span class="w">        </span><span class="sd">&quot;&quot;&quot;Add arguments element-wise.&quot;&quot;&quot;</span>
        <span class="n">queue</span> <span class="o">=</span> <span class="p">[</span><span class="n">arr</span> <span class="k">for</span> <span class="n">arr</span> <span class="ow">in</span> <span class="n">arrays</span><span class="p">]</span>
        <span class="k">if</span> <span class="n">how</span> <span class="o">==</span> <span class="s2">&quot;pairs&quot;</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">queue</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">:</span><span class="mi">2</span><span class="p">],</span> <span class="n">queue</span><span class="p">[</span><span class="mi">1</span><span class="p">::</span><span class="mi">2</span><span class="p">]):</span>
                <span class="k">yield</span> <span class="n">ufunc</span><span class="o">.</span><span class="n">outer</span><span class="p">(</span><span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span><span class="p">)</span> <span class="k">if</span> <span class="n">outer</span> <span class="k">else</span> <span class="n">ufunc</span><span class="p">(</span><span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">how</span> <span class="o">==</span> <span class="s2">&quot;adjacent&quot;</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">queue</span><span class="p">[:</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">queue</span><span class="p">[</span><span class="mi">1</span><span class="p">:]):</span>
                <span class="k">yield</span> <span class="n">ufunc</span><span class="o">.</span><span class="n">outer</span><span class="p">(</span><span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span><span class="p">)</span> <span class="k">if</span> <span class="n">outer</span> <span class="k">else</span> <span class="n">ufunc</span><span class="p">(</span><span class="n">lhs</span><span class="p">,</span> <span class="n">rhs</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">how</span> <span class="o">==</span> <span class="s2">&quot;reduce&quot;</span><span class="p">:</span>
            <span class="k">yield</span> <span class="n">ufunc</span><span class="o">.</span><span class="n">reduce</span><span class="p">(</span><span class="n">queue</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">how</span> <span class="o">==</span> <span class="s2">&quot;accumulate&quot;</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">result</span> <span class="ow">in</span> <span class="n">ufunc</span><span class="o">.</span><span class="n">accumulate</span><span class="p">(</span><span class="n">queue</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
                <span class="k">yield</span> <span class="n">result</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;The requested addition method is not supported.&quot;</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">update_wrapper</span><span class="p">(</span><span class="n">binary</span><span class="p">,</span> <span class="n">ufunc</span><span class="p">)</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">numpy</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../cnp.html">Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>